Index: issm/trunk-jpl/src/m/classes/linearbasalforcings.m
===================================================================
--- issm/trunk-jpl/src/m/classes/linearbasalforcings.m	(revision 22503)
+++ issm/trunk-jpl/src/m/classes/linearbasalforcings.m	(revision 22505)
@@ -79,10 +79,5 @@
 			yts=md.constants.yts;
 
-			floatingice_melting_rate=zeros(md.mesh.numberofvertices,1);
-			floatingice_melting_rate(find(md.geometry.base<=md.basalforcings.deepwater_elevation(1,1)))=md.basalforcings.deepwater_melting_rate(1,1);
-			pos=find(md.geometry.base>md.basalforcings.deepwater_elevation(1,1) & md.geometry.base<md.basalforcings.upperwater_elevation(1,1));
-			floatingice_melting_rate(pos)=md.basalforcings.deepwater_melting_rate(1,1)*(md.geometry.base(pos)-md.basalforcings.upperwater_elevation(1,1))/(md.basalforcings.deepwater_elevation(1,1)-md.basalforcings.upperwater_elevation(1,1));
 			WriteData(fid,prefix,'name','md.basalforcings.model','data',2,'format','Integer');
-			WriteData(fid,prefix,'data',floatingice_melting_rate,'format','DoubleMat','name','md.basalforcings.floatingice_melting_rate','mattype',1,'scale',1./yts,'timeserieslength',md.mesh.numberofvertices+1,'yts',md.constants.yts)
 			WriteData(fid,prefix,'object',self,'fieldname','groundedice_melting_rate','format','DoubleMat','name','md.basalforcings.groundedice_melting_rate','mattype',1,'scale',1./yts,'timeserieslength',md.mesh.numberofvertices+1,'yts',md.constants.yts)
 			WriteData(fid,prefix,'object',self,'fieldname','geothermalflux','name','md.basalforcings.geothermalflux','format','DoubleMat','mattype',1,'timeserieslength',md.mesh.numberofvertices+1,'yts',md.constants.yts);
Index: issm/trunk-jpl/src/m/classes/linearbasalforcings.py
===================================================================
--- issm/trunk-jpl/src/m/classes/linearbasalforcings.py	(revision 22503)
+++ issm/trunk-jpl/src/m/classes/linearbasalforcings.py	(revision 22505)
@@ -92,15 +92,5 @@
 		yts=md.constants.yts
 
-		floatingice_melting_rate = np.zeros((md.mesh.numberofvertices))
-
-		pos = np.nonzero(md.geometry.base <= md.basalforcings.deepwater_elevation)
-		floatingice_melting_rate[pos] = md.basalforcings.deepwater_melting_rate[0][0]
-
-		pos = np.nonzero(np.logical_and(md.geometry.base > md.basalforcings.deepwater_elevation, md.geometry.base < md.basalforcings.upperwater_elevation))
-
-		floatingice_melting_rate[pos] =	md.basalforcings.deepwater_melting_rate[0][0] * (md.geometry.base[pos] - md.basalforcings.upperwater_elevation) / (md.basalforcings.deepwater_elevation - md.basalforcings.upperwater_elevation)
-
 		WriteData(fid,prefix,'name','md.basalforcings.model','data',2,'format','Integer')
-		WriteData(fid,prefix,'data',floatingice_melting_rate,'name','md.basalforcings.floatingice_melting_rate','format','DoubleMat','mattype',1,'scale',1./yts,'timeserieslength',md.mesh.numberofvertices+1,'yts',md.constants.yts)
 		WriteData(fid,prefix,'object',self,'fieldname','groundedice_melting_rate','name','md.basalforcings.groundedice_melting_rate','format','DoubleMat','mattype',1,'scale',1./yts,'timeserieslength',md.mesh.numberofvertices+1,'yts',md.constants.yts)
 		WriteData(fid,prefix,'object',self,'fieldname','geothermalflux','name','md.basalforcings.geothermalflux','format','DoubleMat','mattype',1,'timeserieslength',md.mesh.numberofvertices+1,'yts',md.constants.yts)
Index: issm/trunk-jpl/src/m/classes/mismipbasalforcings.m
===================================================================
--- issm/trunk-jpl/src/m/classes/mismipbasalforcings.m	(revision 22503)
+++ issm/trunk-jpl/src/m/classes/mismipbasalforcings.m	(revision 22505)
@@ -85,9 +85,5 @@
 			end
 
-			floatingice_melting_rate=zeros(md.mesh.numberofvertices,1);
-			floatingice_melting_rate=md.basalforcings.meltrate_factor*tanh((md.geometry.base-md.geometry.bed)./md.basalforcings.threshold_thickness).*max(md.basalforcings.upperdepth_melt-md.geometry.base,0);
-
 			WriteData(fid,prefix,'name','md.basalforcings.model','data',3,'format','Integer');
-			WriteData(fid,prefix,'data',floatingice_melting_rate,'format','DoubleMat','name','md.basalforcings.floatingice_melting_rate','mattype',1,'scale',1./yts,'timeserieslength',md.mesh.numberofvertices+1,'yts',md.constants.yts)
 			WriteData(fid,prefix,'object',self,'fieldname','groundedice_melting_rate','format','DoubleMat','name','md.basalforcings.groundedice_melting_rate','mattype',1,'scale',1./yts,'timeserieslength',md.mesh.numberofvertices+1,'yts',md.constants.yts)
 			WriteData(fid,prefix,'object',self,'fieldname','geothermalflux','name','md.basalforcings.geothermalflux','format','DoubleMat','mattype',1,'timeserieslength',md.mesh.numberofvertices+1,'yts',md.constants.yts);
Index: issm/trunk-jpl/src/m/classes/mismipbasalforcings.py
===================================================================
--- issm/trunk-jpl/src/m/classes/mismipbasalforcings.py	(revision 22503)
+++ issm/trunk-jpl/src/m/classes/mismipbasalforcings.py	(revision 22505)
@@ -86,9 +86,5 @@
             print 'WARNING: value of yts for MISMIP+ runs different from ISSM default!'
 
-        floatingice_melting_rate = np.zeros((md.mesh.numberofvertices))
-        floatingice_melting_rate = md.basalforcings.meltrate_factor*np.tanh((md.geometry.base-md.geometry.bed)/md.basalforcings.threshold_thickness)*(md.basalforcings.upperdepth_melt-md.geometry.base)
-
 	WriteData(fid,prefix,'name','md.basalforcings.model','data',3,'format','Integer')
-	WriteData(fid,prefix,'data',floatingice_melting_rate,'format','DoubleMat','name','md.basalforcings.floatingice_melting_rate','mattype',1,'scale',1./yts,'timeserieslength',md.mesh.numberofvertices+1,'yts',md.constants.yts)
 	WriteData(fid,prefix,'object',self,'fieldname','groundedice_melting_rate','format','DoubleMat','name','md.basalforcings.groundedice_melting_rate','mattype',1,'scale',1./yts,'timeserieslength',md.mesh.numberofvertices+1,'yts',md.constants.yts)
 	WriteData(fid,prefix,'object',self,'fieldname','geothermalflux','name','md.basalforcings.geothermalflux','format','DoubleMat','mattype',1,'timeserieslength',md.mesh.numberofvertices+1,'yts',md.constants.yts)