Index: issm/trunk-jpl/test/NightlyRun/test236.py
===================================================================
--- issm/trunk-jpl/test/NightlyRun/test236.py	(revision 21408)
+++ issm/trunk-jpl/test/NightlyRun/test236.py	(revision 22864)
@@ -40,8 +40,8 @@
 
 # creating initialization and spc temperatures initialization and spc
-md.thermal.spctemperature=np.mean(md.smb.temperatures_lgm[0:md.mesh.numberofvertices,:],axis=1).reshape(-1,1)    #-10*ones(md.mesh.numberofvertices,1)
-md.thermal.spctemperature=np.tile(md.thermal.spctemperature,(1,md.timestepping.final_time/md.timestepping.time_step))
+md.thermal.spctemperature=np.mean(md.smb.temperatures_lgm[0:md.mesh.numberofvertices,:],axis=1)    #-10*ones(md.mesh.numberofvertices,1)
+md.thermal.spctemperature=np.tile(md.thermal.spctemperature,(int(md.timestepping.final_time/md.timestepping.time_step),1)).T
 itemp=np.arange(0,md.timestepping.final_time,md.timestepping.time_step)
-md.thermal.spctemperature=np.vstack((md.thermal.spctemperature,itemp.reshape(1,-1)))
+md.thermal.spctemperature=np.vstack((md.thermal.spctemperature,itemp))
 
 md.initialization.temperature=md.smb.temperatures_lgm[0:md.mesh.numberofvertices,0]    #*ones(md.mesh.numberofvertices,1)
@@ -52,15 +52,15 @@
 md.smb.precipitations_lgm=np.zeros((md.mesh.numberofvertices+1,12))
 for imonth in xrange(0,12):
-    md.smb.precipitations_presentday[0:md.mesh.numberofvertices,imonth]=-0.4*10**(-6)*md.mesh.y+0.5
-    md.smb.precipitations_presentday[md.mesh.numberofvertices,imonth]=((float(imonth)+1.)/12.)
-    md.smb.precipitations_lgm[0:md.mesh.numberofvertices,imonth]=-0.4*10**(-6)*md.mesh.y+0.5
-    md.smb.precipitations_lgm[md.mesh.numberofvertices,imonth]=((float(imonth)+1.)/12.)
+	md.smb.precipitations_presentday[0:md.mesh.numberofvertices,imonth]=-0.4*10**(-6)*md.mesh.y+0.5
+	md.smb.precipitations_presentday[md.mesh.numberofvertices,imonth]=((float(imonth)+1.)/12.)
+	md.smb.precipitations_lgm[0:md.mesh.numberofvertices,imonth]=-0.4*10**(-6)*md.mesh.y+0.5
+	md.smb.precipitations_lgm[md.mesh.numberofvertices,imonth]=((float(imonth)+1.)/12.)
 
 # Interpolation factors
-md.smb.Tdiff=0.5*np.ones((2,md.timestepping.final_time))
-md.smb.sealev=0.5*np.ones((2,md.timestepping.final_time))
+md.smb.Tdiff=0.5*np.ones((2,int(md.timestepping.final_time)))
+md.smb.sealev=0.5*np.ones((2,int(md.timestepping.final_time)))
 # Year of each data point
-md.smb.Tdiff[1,1:md.timestepping.final_time]=np.arange(1.,md.timestepping.final_time)
-md.smb.sealev[1,1:md.timestepping.final_time]=np.arange(1.,md.timestepping.final_time)
+md.smb.Tdiff[1,1:int(md.timestepping.final_time)]=np.arange(1.,int(md.timestepping.final_time))
+md.smb.sealev[1,1:int(md.timestepping.final_time)]=np.arange(1.,int(md.timestepping.final_time))
 
 # time steps and resolution
@@ -69,5 +69,5 @@
 
 
-# 
+#
 md.transient.requested_outputs=['default','SmbMonthlytemperatures']
 md=setflowequation(md,'SSA','all')
@@ -76,37 +76,35 @@
 
 #Fields and tolerances to track changes
-field_names     =['Vx1','Vy1','Vel1','Pressure1','Bed1','Surface1','Thickness1','SmbMonthlytemperatures1','SmbMassBalance1',\
-		            'Vx2','Vy2','Vel2','Pressure2','Bed2','Surface2','Thickness2','SmbMonthlytemperatures2','SmbMassBalance2',\
-				      'Vx3','Vy3','Vel3','Pressure3','Bed3','Surface3','Thickness3','SmbMonthlytemperatures3','SmbMassBalance3']
-field_tolerances=[1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,\
-		            1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,\
-			         1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13]
-field_values=[\
-	md.results.TransientSolution[0].Vx,\
-	md.results.TransientSolution[0].Vy,\
-	md.results.TransientSolution[0].Vel,\
-	md.results.TransientSolution[0].Pressure,\
-	md.results.TransientSolution[0].Base,\
-	md.results.TransientSolution[0].Surface,\
-	md.results.TransientSolution[0].Thickness,\
-	md.results.TransientSolution[0].SmbMonthlytemperatures,\
-	md.results.TransientSolution[0].SmbMassBalance,\
-	md.results.TransientSolution[1].Vx,\
-	md.results.TransientSolution[1].Vy,\
-	md.results.TransientSolution[1].Vel,\
-	md.results.TransientSolution[1].Pressure,\
-	md.results.TransientSolution[1].Base,\
-	md.results.TransientSolution[1].Surface,\
-	md.results.TransientSolution[1].Thickness,\
-	md.results.TransientSolution[1].SmbMonthlytemperatures,\
-	md.results.TransientSolution[1].SmbMassBalance,\
-	md.results.TransientSolution[2].Vx,\
-	md.results.TransientSolution[2].Vy,\
-	md.results.TransientSolution[2].Vel,\
-	md.results.TransientSolution[2].Pressure,\
-	md.results.TransientSolution[2].Base,\
-	md.results.TransientSolution[2].Surface,\
-	md.results.TransientSolution[2].Thickness,\
-	md.results.TransientSolution[2].SmbMonthlytemperatures,\
-	md.results.TransientSolution[2].SmbMassBalance,\
-	]
+field_names     =['Vx1','Vy1','Vel1','Pressure1','Bed1','Surface1','Thickness1','SmbMonthlytemperatures1','SmbMassBalance1',
+									'Vx2','Vy2','Vel2','Pressure2','Bed2','Surface2','Thickness2','SmbMonthlytemperatures2','SmbMassBalance2',
+									'Vx3','Vy3','Vel3','Pressure3','Bed3','Surface3','Thickness3','SmbMonthlytemperatures3','SmbMassBalance3']
+field_tolerances=[1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,
+									1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,
+									1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13,1e-13]
+field_values=[md.results.TransientSolution[0].Vx,
+							md.results.TransientSolution[0].Vy,
+							md.results.TransientSolution[0].Vel,
+							md.results.TransientSolution[0].Pressure,
+							md.results.TransientSolution[0].Base,
+							md.results.TransientSolution[0].Surface,
+							md.results.TransientSolution[0].Thickness,
+							md.results.TransientSolution[0].SmbMonthlytemperatures,
+							md.results.TransientSolution[0].SmbMassBalance,
+							md.results.TransientSolution[1].Vx,
+							md.results.TransientSolution[1].Vy,
+							md.results.TransientSolution[1].Vel,
+							md.results.TransientSolution[1].Pressure,
+							md.results.TransientSolution[1].Base,
+							md.results.TransientSolution[1].Surface,
+							md.results.TransientSolution[1].Thickness,
+							md.results.TransientSolution[1].SmbMonthlytemperatures,
+							md.results.TransientSolution[1].SmbMassBalance,
+							md.results.TransientSolution[2].Vx,
+							md.results.TransientSolution[2].Vy,
+							md.results.TransientSolution[2].Vel,
+							md.results.TransientSolution[2].Pressure,
+							md.results.TransientSolution[2].Base,
+							md.results.TransientSolution[2].Surface,
+							md.results.TransientSolution[2].Thickness,
+							md.results.TransientSolution[2].SmbMonthlytemperatures,
+							md.results.TransientSolution[2].SmbMassBalance]